import math, random
from ball import *

class EnemyAI:
	BULKING = 0
	ATTACKING = 1
	
	def __init__(self, enemy, enemy_group, player, enemy_rain):
		self.enemy = enemy
		self.group = enemy_group
		self.rain  = enemy_rain
		self.player = player
		self.state = EnemyAI.BULKING
		self.drop = None
		self.timeout = pygame.time.get_ticks()
		self.momentum = 0
		
	def tick(self):
		if self.timeout <= pygame.time.get_ticks():
			if self.state == EnemyAI.ATTACKING:
				self.timeout = random.randint(pygame.time.get_ticks() + 5000, 
					(pygame.time.get_ticks() + 5000) + int((1.0/len(self.group.sprites())) * 30000))
				self.state = EnemyAI.BULKING
			else:
				self.timeout = random.randint(pygame.time.get_ticks() + 1000,
					(pygame.time.get_ticks() + 1000) + (len(self.group.sprites()) * 300))
				self.state = EnemyAI.ATTACKING
		if (len(self.group.sprites()) < 8):
			self.state = EnemyAI.BULKING
			
		if self.state == EnemyAI.ATTACKING:
			yvel = 0
			if (self.enemy.pos[1] < 47):
				yvel = Global.VELOCITY
			if (self.enemy.pos[1] > 53):
				yvel = -Global.VELOCITY
				
			if (self.player.pos[0] < (self.enemy.pos[0] + self.momentum)):
				self.enemy.move((-Global.VELOCITY, yvel))
				self.momentum = -Global.VELOCITY * 3
			elif (self.player.pos[0] > (self.enemy.pos[0] + self.momentum)):
				self.enemy.move((Global.VELOCITY, yvel))
				self.momentum = Global.VELOCITY * 3
			else:
				self.momentum = 0
		else:
			if not self.rain.has(self.drop):
				self.drop = None
			if self.drop == None:
				for drop in self.rain.sprites():
					if self.drop == None:
						self.drop = drop
					else:
						if (abs(self.drop.pos[0] - self.enemy.pos[0]) + (self.drop.pos[1] - self.enemy.pos[1])) > (abs(drop.pos[0] - self.enemy.pos[0]) + (drop.pos[1] - self.enemy.pos[1])):
							self.drop = drop

			if self.drop:
				if (self.drop.pos[1] > self.enemy.pos[1]) and (self.enemy.pos[1] < (Global.SCREEN_H / 3)):
					yvel = Global.VELOCITY
				else:
					yvel = -Global.VELOCITY
				if (self.drop.pos[0] < self.enemy.pos[0]):
					xvel = -Global.VELOCITY
				else:
					xvel = Global.VELOCITY
				self.enemy.move((xvel, yvel))
				
		
		if (abs(self.player.pos[0] - self.enemy.pos[0]) < 25) and (random.randint(0, 13) == 0):
			self.enemy.shoot()