import pygame
from pygame.locals import *
from globals import *
from ball import *

class PlayerController:
	def __init__(self, player):
		self.shooting = False
		self.player = player
	
	def tick(self):
		keys = pygame.key.get_pressed()
		if (self.shooting):
			if not keys[K_SPACE]:
				self.shooting = False
		else:
			if keys[K_SPACE]:
				self.shooting = True
				self.player.shoot()
		
		vel = (0,0)
		if keys[K_LEFT] and self.player.pos[0] > Ball.WIDTH:
			vel = (vel[0] - Global.VELOCITY, vel[1])
		if keys[K_RIGHT] and self.player.pos[0] < (Global.SCREEN_W - Ball.WIDTH):
			vel = (vel[0] + Global.VELOCITY, vel[1])
		if keys[K_UP] and self.player.pos[1] > (2 * (Global.SCREEN_H / 3)):
			vel = (vel[0], vel[1] - Global.VELOCITY)
		if keys[K_DOWN] and self.player.pos[1] < (Global.SCREEN_H - Ball.WIDTH):
			vel = (vel[0], vel[1] + Global.VELOCITY)
		
		self.player.move(vel)