import pygame, random
from pygame.locals import *
from globals import *
from ball import *

class RainDropper:
	def __init__(self, ystart, yvel, type, group, attractor):
		self.ystart = ystart
		self.yvel = yvel
		self.type = type
		self.ball_group = group
		self.attractor = attractor
	
	def spawn(self):
		if self.type == Global.PLAYER:
			Global.player_rain.add(PlayerBall(self.ball_group, (random.randint(0, Global.SCREEN_W), self.ystart), self.attractor, GameBall.RAIN))
		else:
			Global.enemy_rain.add(EnemyBall(self.ball_group, (random.randint(0, Global.SCREEN_W), self.ystart), self.attractor, GameBall.RAIN))
	
	def tick(self):
		if random.randint(0, 10) == 5:
			self.spawn()
			
class RainEngine:
	def __init__(self):
		self.player_drop = RainDropper(-Ball.HEIGHT, 7, Global.PLAYER, Global.player_balls, Global.player)
		self.enemy_drop = RainDropper(Global.SCREEN_H + Ball.HEIGHT, -7, Global.ENEMY, Global.enemy_balls, Global.enemy)
	
	def tick(self):
		self.player_drop.tick()
		self.enemy_drop.tick()
		